/**
 *	@file	DialogHook.h
 *	@brief	_CAOEtbN
 */

#pragma once


#define PROMPT_CAPTION					_T("Explorer [U[ vvg")
#define STRING_PROMPT_TOOLTIP			_T( "̃EBhEǂ̃^uɂĊJꂽ̂unDonut͔cĂ܂B\nꍇɂĂ̓ANeBuł͂Ȃ^uɊJꂽAȃTCgJUEBhEł\n\܂BOK{^ď𑗐Mۂ͂ӂB")
#define ACTIVEXDIALOG_WINDOWTEXT		_T("Microsoft Internet Explorer")
#define ACTIVEXDIALOG_WINDOWTEXT2		_T("Windows Internet Explorer")
#define ACTIVEXDIALOG_MESSAGE_PARTIAL	_T("݂̃ZLeB̐ݒł́Ãy[W")
#define ACTIVEXDIALOG_MESSAGE_REASONS	_T("̂ꂩ̗Rɂ 1 ܂͂ȏ ActiveX") 	//+++ 2chX"unDonut Part16" 149 𔽉f.



class CDialogHook {
private:
	static HHOOK	s_hHook;
	static HWND 	s_hWndMainFrame;


	enum {
		cnt_offsetX 	= 4,
		cnt_offsetY 	= 4
	};


public:
	static BOOL InstallHook(HWND hWndMainFrame)
	{
		if (s_hHook)
			return FALSE;

		s_hWndMainFrame 	= hWndMainFrame;
		DWORD	dwThreadID	= ::GetCurrentThreadId();
		s_hHook 			= ::SetWindowsHookEx(WH_CALLWNDPROC, CallWndProc, NULL, dwThreadID);
		return s_hHook != 0 /*? TRUE : FALSE*/;
	}


	static BOOL UninstallHook()
	{
		if (!s_hHook)
			return FALSE;

		BOOL bRet = ::UnhookWindowsHookEx(s_hHook) != 0;
		if (bRet)
			s_hHook = NULL;
		return bRet;
	}


private:
	static LRESULT CALLBACK CallWndProc(int nCode, WPARAM wParam, LPARAM lParam)
	{
		if (nCode < 0)
			return ::CallNextHookEx(s_hHook, nCode, wParam, lParam);

		CWPSTRUCT *pcwp = (CWPSTRUCT *) lParam;

		if (pcwp->message == WM_INITDIALOG) {
			//_CAOߑ
			LRESULT lRet	   = ::CallNextHookEx(s_hHook, nCode, wParam, lParam); //s

			//_CAÕEBhEnh擾
			HWND	hWndFocus  = (HWND) pcwp->wParam;
			if ( !::IsWindow(hWndFocus) )
				return lRet;

			HWND	hDialog    = ::GetParent(hWndFocus);
			if ( !::IsWindow(hDialog) )
				return lRet;

			//_CAO̐eEBhEŏʃEBhEł邱ƂmF
			if (::GetParent(hDialog) != s_hWndMainFrame)
				return lRet;

			//LvV`FbN
			CString strCaption = MtlGetWindowText(hDialog);

			if (strCaption == PROMPT_CAPTION) {
				//promptɂĐꂽ_CAOƔ
				PromptWindowProc(hDialog);
			} else if (strCaption == ACTIVEXDIALOG_WINDOWTEXT
					|| strCaption == ACTIVEXDIALOG_WINDOWTEXT2		//+++ for IE7.
			) {
				//IẼbZ[W{bNX
				HWND hWndStatic = ::GetDlgItem(hDialog, 0x0000FFFF);

				if ( ::IsWindow(hWndStatic) ) {
					CString strStaticText = MtlGetWindowText(hWndStatic);

					if (   strStaticText.Find(ACTIVEXDIALOG_MESSAGE_PARTIAL) != -1
						|| strStaticText.Find(ACTIVEXDIALOG_MESSAGE_REASONS) != -1		//+++ 2chX"unDonut Part16" 149 𔽉f.
					) {
						if ( _check_flag(MAIN_EX_KILLDIALOG, CMainOption::s_dwMainExtendedStyle) ) {
							//::SendMessage(hDialog,WM_CLOSE,0,0);
							::DestroyWindow(hDialog);
						}
					}
				}
			}

			return lRet;
		}

		return ::CallNextHookEx(s_hHook, nCode, wParam, lParam);
	}


	static BOOL PromptWindowProc(HWND hWnd)
	{
		HWND	 hOkButton = GetDlgItem(hWnd, 1);	//OK{^ID1Ɖ肵ănh擾
		if (!hOkButton)
			return FALSE;

		HWND	 hToolTip  = ::CreateWindow(TOOLTIPS_CLASS,
											NULL,
											TTS_ALWAYSTIP,
											CW_USEDEFAULT,
											CW_USEDEFAULT,
											CW_USEDEFAULT,
											CW_USEDEFAULT,
											hWnd,
											NULL,
											_Module.GetModuleInstance(),
											NULL);
		if (!hToolTip)
			return FALSE;

		TOOLINFO	ti	= { sizeof (TOOLINFO) };
		ti.uFlags		= TTF_SUBCLASS | TTF_IDISHWND;
		ti.hwnd 		= hOkButton;
		ti.uId			= (UINT_PTR) hOkButton;

		RECT	 rc;
		::GetWindowRect(hOkButton, &rc);
		ti.hinst		= _Module.GetModuleInstance();
		ti.lpszText 	= STRING_PROMPT_TOOLTIP;

		//c[`bv̐ݒ
		::SendMessage(hToolTip , TTM_ADDTOOL	   , 0, (LPARAM) &ti);						//c[`bv̒ǉ
		::SendMessage(hToolTip , TTM_SETMAXTIPWIDTH, 0, (LPARAM) 500);						//eLXgs悤ɂ
		::SendMessage( hToolTip, TTM_SETDELAYTIME  , TTDT_INITIAL, MAKELONG(1	 , 0) );	//\xق0
		::SendMessage( hToolTip, TTM_SETDELAYTIME  , TTDT_AUTOPOP, MAKELONG(30000, 0) );	//\Ԃ30b

		ti.hwnd 	= hWnd;
		ti.uId		= (UINT_PTR) hWnd;
		::SendMessage(hToolTip, TTM_ADDTOOL, 0, (LPARAM) &ti);

		return TRUE;
	}
};


__declspec(selectany) HHOOK CDialogHook::s_hHook			= NULL;
__declspec(selectany) HWND	CDialogHook::s_hWndMainFrame	= NULL;



#if 0	//+++	łɖgp̂悤.

class CSearchBoxHook {
	static HINSTANCE	s_hInstDLL;

	typedef BOOL (WINAPI   * LPFINSTALLHOOK)(HWND);
	typedef BOOL (WINAPI   * LPFUNINSTALLHOOK)();


public:
	static BOOL InstallSearchHook(HWND hWndMainFrame)
	{
		LPFINSTALLHOOK		fpInstallHook;
		LPFUNINSTALLHOOK	fpUninstallHook;

		if (s_hInstDLL)
			return FALSE;

		s_hInstDLL		= ::LoadLibrary( _T("SearchHook.dll") );
		if (!s_hInstDLL)
			return FALSE;

		//ŁAtbNOɃtbN֐݂邩mFi肷ƔߎSj
		fpUninstallHook = (LPFUNINSTALLHOOK) ::GetProcAddress( s_hInstDLL, _T("UninstallHook") );
		if (!fpUninstallHook)
			goto CLEAR;

		fpInstallHook	= (LPFINSTALLHOOK) ::GetProcAddress( s_hInstDLL, _T("InstallHook") );
		if (!fpInstallHook)
			goto CLEAR;

		if ( !fpInstallHook(hWndMainFrame) )
			goto CLEAR;

		return TRUE;

	  CLEAR:
		if (s_hInstDLL)
			::FreeLibrary(s_hInstDLL);

		s_hInstDLL		= NULL;
		return FALSE;
	}


	static BOOL UninstallSearchHook()
	{
		if (!s_hInstDLL)
			return FALSE;

		LPFUNINSTALLHOOK fpUninstallHook = (LPFUNINSTALLHOOK) ::GetProcAddress( s_hInstDLL, _T("UninstallHook") );

		if (!fpUninstallHook)
			return FALSE;

		//ŖƂĂ
		BOOL	bRet	= fpUninstallHook();
		if (!bRet)
			return FALSE;

		//̂
		::FreeLibrary(s_hInstDLL);
		s_hInstDLL = NULL;
		return TRUE;
	}
};


__declspec(selectany) HINSTANCE CSearchBoxHook::s_hInstDLL = NULL;


#endif
