/**
 *	@file	PluginManager.cpp
 *	@brief	vOCE}l[W
 */

#include "stdafx.h"
#include "PluginManager.h"
#include "IniFile.h"
#include "DonutDefine.h"
#include "DonutPFunc.h"
#include "option/PluginDialog.h"


#if defined USE_ATLDBGMEM
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



using namespace 	std;
using namespace 	MTL;



vector<CPluginManager::PluginData> *	CPluginManager::m_avecData = NULL;


/*
	nKind  1 Origin 1toPLUGIN_TYPECNT
	ƂƂYďĂЂǂڂɂ
 */



/// vOC\̂̃|C^擾
CPluginManager::PluginData *CPluginManager::GetDataPtr(int nKind, int nIndex)
{
	ATLASSERT(m_avecData != NULL);

	if (nKind <= 0 || PLUGIN_TYPECNT < nKind)
		return NULL;

	PluginArray *pary = &m_avecData[nKind];

	if (nIndex < 0 || (int) pary->size() <= nIndex)
		return NULL;

	return &pary->at(nIndex);
}



/// [hɎsvOCЕt
void CPluginManager::SettleBadPlugin(int nKind, int nIndex, PluginData &data, HWND hWnd)
{
	TCHAR 	szBuf[MAX_PATH];
	szBuf[0]	= 0;	//+++
	::GetModuleFileName( data.hInstDLL, szBuf, MAX_PATH );
	ErrMsg_FailLoad(data.strCaption, szBuf, hWnd);
	RemovePlugin(nKind, nIndex);
}



BOOL CPluginManager::ReleasePluginData(PluginData &data)
{
	if ( ::IsWindow(data.hWnd) ) {
		try {	//+++
			::DestroyWindow(data.hWnd);
			data.hWnd = NULL;
		} catch (...) {
		  #ifdef _DEBUG
			FILE *fp = fopen("errlog.txt", "a");

			if (fp) {
				fprintf(fp, "vOC\"%s\"̏IɃG[܂B\n", data.strCaption);
				fclose(fp);
			}
		  #endif //_DEBUG
		}
	}

	if (data.hInstDLL) {
		::FreeLibrary(data.hInstDLL);
		data.hInstDLL = NULL;
	}

	return TRUE;
}



/// vOCz񂩂폜iEBhE̊Jsj
BOOL CPluginManager::RemovePlugin(int nKind, int nIndex)
{
	ATLASSERT(m_avecData != NULL);

	if (nKind <= 0 || PLUGIN_TYPECNT < nKind)
		return FALSE;

	PluginArray *pary = &m_avecData[nKind];

	if (nIndex < 0 || (int) pary->size() <= nIndex)
		return FALSE;

	if ( ReleasePluginData( pary->at(nIndex) ) )
		pary->erase(pary->begin() + nIndex);
	else
		return FALSE;

	return TRUE;
}



void CPluginManager::ErrMsg_FailLoad(LPCTSTR lpstrName, LPCTSTR lpstrPath, HWND hWnd)
{
	CString strMsg;
	strMsg.Format(_T("\"%s\"(%s)\n[h邱Ƃł܂łB\nN͖ɂȂ܂B"), lpstrName, lpstrPath);
	MessageBox(hWnd, strMsg, _T("Plugin"), MB_OK | MB_ICONSTOP);
}



CPluginManager::CPluginManager()
{
}



CPluginManager::~CPluginManager()
{
	ATLASSERT(m_avecData == NULL);
}



void CPluginManager::Init()
{
	m_avecData = new PluginArray[PLUGIN_TYPECNT + 1];
}



void CPluginManager::Term()
{
	DeleteAllPlugin();
	delete[] m_avecData;
	m_avecData = NULL;
}



/// vOC̃^Cg擾
/// BOOL^̗̈ւ̃|C^w肳ΐEsɕԂ
CString CPluginManager::GetCaption(int nKind, int nIndex, BOOL *pbRet)
{
	PluginData *pdata = GetDataPtr(nKind, nIndex);

	if (pdata) {
		if (pbRet)
			*pbRet = TRUE;

		return pdata->strCaption;
	} else {
		if (pbRet)
			*pbRet = FALSE;

		return _T("");
	}
}



/// vOC̃EBhEnh擾
/// sƂA͍쐬ĂȂꍇNULLԂ
HWND CPluginManager::GetHWND(int nKind, int nIndex)
{
	PluginData *pdata = GetDataPtr(nKind, nIndex);

	if (!pdata)
		return NULL;

	return pdata->hWnd;
}



int CPluginManager::GetCount(int nKind)
{
	if (nKind <= 0 || PLUGIN_TYPECNT < nKind)
		return -1;

	return m_avecData[nKind].size();
}



bool CPluginManager::IsEarlyLoading(int nKind, int nIndex)
{
	PluginData *pdata = GetDataPtr(nKind, nIndex);
	if (!pdata)
		return false;

	return (pdata->nStyle & PLUGIN_STYLE_EARLYLOADING) != 0;	//+++ ? true : false;
}



/// DLL̃[hyуvOC̓ǂݍ݂s
BOOL CPluginManager::ReadPluginData(int nKind, HWND hWnd)
{
	if (nKind <= 0 || PLUGIN_TYPECNT < nKind)
		return FALSE;

	CString 	strKey;
	strKey.Format(_T("Plugin%02d"), nKind);

	CIniFileIO	pr(g_szIniFileName, strKey);

	DWORD		dwCount    = 0;
	pr.QueryValue( dwCount, _T("Count") );

	CString 	strDLLPath = Misc::GetExeDirectory() + PluginDir();

	for (int nIndex = 0; nIndex < (int) dwCount; nIndex++) {
		try {	//+++
			strKey.Format(_T("%02d"), nIndex);
			//DLL̃[h
			CString   strDLLFile = strDLLPath + pr.GetString( strKey );
			HINSTANCE hInstDLL	 = ::LoadLibrary( strDLLFile );

			if (hInstDLL) {
				//f[^̏
				PluginData		 data;
				data.hInstDLL  = hInstDLL;
				data.strIniKey = strKey;
				data.fpEvent   = GetPtr_PluginEvent(hInstDLL);

				//GetPluginInfo֐găvOCŗL̏擾
				LPFGETPLUGININFO	pfGetPluginInfo = GetPtr_GetPluginInfo(hInstDLL);
				if (pfGetPluginInfo) {
					PLUGININFO *	ppi = new PLUGININFO;
					pfGetPluginInfo(ppi);
					data.strCaption 	= ppi->name;
					data.nStyle 		= ppi->type & 0xFFFFFFF0;
					delete ppi;
				}

				//f[^o^
				m_avecData[nKind].push_back(data);
			} else {
				//[hɎŝœo^
				ErrMsg_FailLoad(_T("N/A"), strDLLFile, hWnd);
				pr.DeleteValue(strKey);
			}
		} catch (...) {
			ATLASSERT(0);
		}
	}

	return TRUE;
}



/// vOC̃[hs
/// ̓vOC̎ނƔԍƁAgݍސeEBhẼnh
BOOL CPluginManager::LoadPlugin(int nKind, int nIndex, HWND hWndParent, bool bForce)
{
	PluginData *pdata	 = GetDataPtr(nKind, nIndex);

	if (!pdata)
		return FALSE;

	if ( ::IsWindow(pdata->hWnd) )
		return TRUE;

											//Ƀ[hς
	bool		bFuncPtr = false;			//*
	bool		bDelay	 = (pdata->nStyle & PLUGIN_STYLE_EARLYLOADING) == 0;

	if (bDelay && !bForce)
		return TRUE;						//œǂݍ

	try {	//+++
		if (nKind == PLT_TOOLBAR) {
			//c[o[vOC̃[h - CreateToolBar֐̎s
			LPFCREATETOOLBAR pfCreateToolBar = GetPtr_CreateToolBar(pdata->hInstDLL);
			bFuncPtr = pfCreateToolBar != 0;	//+++ ? true : false;

			if (bFuncPtr) {
				pdata->hWnd = pfCreateToolBar(hWndParent, IDC_PLUGIN_TOOLBAR + nIndex);
			}
		} else if (nKind == PLT_EXPLORERBAR) {
			//GNXv[o[vOC̃[h - CreateExplorerPane֐̎s
			LPFCREATEEXPLORERPANE pfCreateExplorerBarPane = GetPtr_CreateExplorerPane(pdata->hInstDLL);
			bFuncPtr = pfCreateExplorerBarPane != 0;	//+++ ? true : false;

			if (bFuncPtr) {
				pdata->hWnd = pfCreateExplorerBarPane(hWndParent, IDC_PLUGIN_EXPLORERBAR + nIndex);
			}
		} else if (nKind == PLT_DOCKINGBAR) {
			//hbLOvOC̃[h - CreatePluginWindow֐̎s
			LPFCREATEPLUGINWINDOW pfCreatePluginWindow = GetPtr_CreatePluginWindow(pdata->hInstDLL);
			bFuncPtr = pfCreatePluginWindow != 0;	//+++ ? true : false;

			if (bFuncPtr) {
				pdata->hWnd = pfCreatePluginWindow(hWndParent);
			}
		} else {
			//ȊO̎ނ̃vOC - Ȃ̂ŃAT[g
			ATLASSERT(FALSE);
		}

		//s̏ꍇ̌Еt
		if ( !bFuncPtr || !::IsWindow(pdata->hWnd) ) {
			SettleBadPlugin(nKind, nIndex, *pdata, hWndParent);
			return FALSE;
		}
	} catch (...) {
		ATLASSERT(0);
	}

	return TRUE;
}



BOOL CPluginManager::LoadAllPlugin(int nKind, HWND hWndParent, bool bForce)
{
	if (nKind <= 0 || PLUGIN_TYPECNT < nKind)
		return FALSE;

	int nCount = GetCount(nKind);

	for (int i = 0; i < nCount; i++) {
		if ( !LoadPlugin(nKind, i, hWndParent, bForce) ) {				//[hsƃf[^
			i--;
			nCount--;
		}
	}

	return TRUE;
}



void CPluginManager::DeleteAllPlugin(int nKind)
{
	if (!m_avecData)
		return;

	int nStart, nEnd;

	if (nKind == -1) {
		nStart = 1;
		nEnd   = PLUGIN_TYPECNT;
	} else if (1 <= nKind && nKind <= PLUGIN_TYPECNT) {
		nStart = nEnd = nKind;
	} else {
		return;
	}

	for (int i = nStart; i <= nEnd; i++) {
		PluginArray *		  pary = &m_avecData[i];
		PluginArray::iterator it;

		for (it = pary->begin(); it != pary->end(); ++it)
			ReleasePluginData(*it);

		pary->clear();
	}
}



/// vOC̊֐Ăяo[`
void CPluginManager::Call_ShowExplorerMenu(int nIndex, int x, int y)	//GNXv[o[̂݃T|[g
{
	PluginData *		pdata			   = GetDataPtr(PLT_EXPLORERBAR, nIndex);

	if (!pdata)
		return;

	LPFSHOWEXPLORERMENU fpShowExplorerMenu = GetPtr_ShowExplorerMenu(pdata->hInstDLL);

	if (!fpShowExplorerMenu)
		return;

	fpShowExplorerMenu(x, y);
}



int CPluginManager::Call_PluginEvent(int nKind, int nIndex, UINT uMsg , FPARAM fParam, SPARAM sParam)
{
	PluginData *   pdata		 = GetDataPtr(nKind, nIndex);

	if (!pdata)
		return 0;

	try {	//+++
		LPFPLUGINEVENT fpPluginEvent = GetPtr_PluginEvent(pdata->hInstDLL);

		if (!fpPluginEvent)
			return 0;

		return fpPluginEvent(uMsg, fParam, sParam);
	} catch (...) {	//+++
		ATLASSERT(0);
	}
	return 0;
}



BOOL CPluginManager::Call_PreTranslateMessage(int nKind, int nIndex, MSG *lpMsg)
{
	PluginData *		   pdata	= GetDataPtr(nKind, nIndex);
	if (!pdata)
		return FALSE;
	try {	//+++
		LPFPRETRANSLATEMESSAGE fpPreTranslateMessage = GetPtr_PreTranslateMessage(pdata->hInstDLL);

		if (!fpPreTranslateMessage)
			return FALSE;

		return fpPreTranslateMessage(lpMsg);
	} catch (...) {
		ATLASSERT(0);
	}
	return FALSE;
}



void CPluginManager::Call_PluginSetting(int nKind, int nIndex)
{
	PluginData *	 pdata	= GetDataPtr(nKind, nIndex);
	if (!pdata)
		return;

	LPFPLUGINSETTING fpPluginSetting = GetPtr_PluginSetting(pdata->hInstDLL);

	if (!fpPluginSetting)
		return;

	fpPluginSetting();
}



BOOL CPluginManager::Call_Event_TabChanged(int nKind, int nIndex, int nNewTabIndex, IWebBrowser *pWB)	//obsolete
{
	PluginData *		pdata = GetDataPtr(nKind, nIndex);
	if (!pdata)
		return FALSE;

	LPFEVENT_TABCHANGED fpEvent_TabChanged = GetPtr_Event_TabChanged(pdata->hInstDLL);

	if (!fpEvent_TabChanged)
		return FALSE;

	return fpEvent_TabChanged(nNewTabIndex, pWB);
}



void CPluginManager::Call_ShowToolBarMenu(int nKind, int nIndex, UINT uID)								//c[o[vOĈ݂̃T|[g
{
	PluginData *	   pdata = GetDataPtr(nKind, nIndex);
	if (!pdata)
		return;

	LPFSHOWTOOLBARMENU fpShowToolBarMenu = GetPtr_ShowToolBarMenu(pdata->hInstDLL);

	if (!fpShowToolBarMenu)
		return;

	fpShowToolBarMenu(uID);
}



/// SẴvOCɑ΂ăCxg𑗂
void CPluginManager::BroadCast_PluginEvent(UINT uMsg, FPARAM fParam, SPARAM sParam)
{
	if (!m_avecData)
		return;

	for (int nKind = 1; nKind <= PLUGIN_TYPECNT; nKind++) {
		int nCount = m_avecData[nKind].size();

		for (int i = 0; i < nCount; i++) {
			Call_PluginEvent(nKind, i, uMsg, fParam, sParam);
		}
	}
}



/// SẴvOCɑ΂ăCxgɑA0̒lԂꂽ_ŏI
int CPluginManager::ChainCast_PluginEvent(UINT uMsg, FPARAM fParam, SPARAM sParam)
{
	if (!m_avecData)
		return 0;

	for (int nKind = 1; nKind <= PLUGIN_TYPECNT; nKind++) {
		int nCount = m_avecData[nKind].size();

		for (int i = 0; i < nCount; i++) {
			int nRet = Call_PluginEvent(nKind, i, uMsg, fParam, sParam);
			if (nRet != 0)
				return nRet;
		}
	}

	return 0;
}



///+++ "Plugin"tH_Ԃ. ܂ Plugin32\ (64rbgł Plugin64\) ݂΂Ԃ"Plugin"Ԃ.
CString CPluginManager::PluginDir()
{
  #ifdef WIN64
	const TCHAR* dir = _T("Plugin64");
  #else
	const TCHAR* dir = _T("Plugin32");
  #endif
	if (Misc::IsExistFile(Misc::GetExeDirectory() + dir) == 0)
		dir = _T("Plugin");
	return CString(dir) + _T('\\');
}

